/*
   client/map.h
   This file is part of the Osirion project and is distributed under
   the terms of the GNU General Public License version 2
*/

#ifndef __INCLUDED_CLIENT_MAP_H__
#define __INCLUDED_CLIENT_MAP_H__

#include "ui/window.h"
#include "ui/label.h"
#include "core/entity.h"

namespace client
{

class Map : public ui::Window
{
public:
	Map(ui::Widget *parent = 0);
	virtual ~Map();

	inline unsigned int hover() const {
		return map_hover;
	}

	/// toggle the map window
	void toggle();

	/// hide the map window
	virtual void hide();

	/// show the map window
	virtual void show();

	/// called when the widget receives a key press
	virtual bool on_keypress(const int key, const unsigned int modifier);

protected:
	virtual void draw();

	unsigned int		map_hover;

	core::Entity		*map_target;
	ui::Label		*map_targetlabel;
};


} // namespace client


#endif // __INCLUDED_CLIENT_MAP_H__

