/*
   filesystem/ifilestream.h
   This file is part of the Osirion project and is distributed under
   the terms of the GNU General Public License version 2
*/

#ifndef __INCLUDED_FILESYSTEM_FILESTREAM_H__
#define __INCLUDED_FILESYSTEM_FILESTREAM_H__

#include <fstream>

namespace filesystem
{

/**
 * @brief input stream for files in the virtual filesystem
 */
class IFileStream : public std::ifstream
{
public:
	IFileStream(const char *name = 0);

	IFileStream(const std::string &name);

	void open(const char *name);

	void open(const std::string &name);

	/// name of the file in the virtual filesystem
	inline const std::string &name() const {
		return fstream_name;
	}

	/// actual dilename
	inline const std::string &filename() const {
		return fstream_filename;
	}

private:
	std::string	fstream_name;
	std::string	fstream_filename;
};

/**
 * @brief output stream for files in the home directory
 */
/*
class OFileStream : public std::ofstream
{
public:
	IFileStream(const char *filename);

	IFileStream(const std::string &filename);

	void open(const char *filename);

	void open(const std::string &filename);

	/// name of the file in the virtual filesystem
	inline const std::string &name() { return fstream_name; }

	/// system filename
	inline const std::string &filename() { return fstream_filename; }

private:
	std::string	fstream_name;
	std::string	fstream_filename;
};
*/

} // namespace filesystem

#endif // __INCLUDED_FILESYSTEM_FILESTREAM_H__

