/*
   base/station.h
   This file is part of the Osirion project and is distributed under
   the terms and conditions of the GNU General Public License version 2
*/

#ifndef __INCLUDED_BASE_STATION_H__
#define __INCLUDED_BASE_STATION_H__

#include "base/shipdealer.h"
#include "base/physics.h"

namespace game
{

class Station : public core::Entity, public PhysicsBody
{
public:
	Station();
	virtual ~Station();

	inline ShipDealer *shipdealer() {
		return station_shipdealer;
	}

	void set_shipdealer(ShipDealer *shipdealer);

	/// entity received a docking request
	virtual void dock(core::Entity *entity);


private:
	ShipDealer		*station_shipdealer;

};

}

#endif // __INCLUDED_BASE_SHIPDEALER_H__

